/*
* Copyright (c) 2011, diablitozzz.org All rights reserved. Redistribution
* and use in source and binary forms, with or without modification, are
* permitted provided that the following conditions are met: * Redistributions
* of source code must retain the above copyright notice, this list of
* conditions and the following disclaimer. * Redistributions in binary form
* must reproduce the above copyright notice, this list of conditions and the
* following disclaimer in the documentation and/or other materials provided
* with the distribution. * Neither the name of diablitozzz.org nor the names of
* its contributors may be used to endorse or promote products derived from this
* software without specific prior written permission. THIS SOFTWARE IS PROVIDED
* BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
* EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS;
* OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package org.diablitozzz.jera.jetty.ant;

import org.apache.tools.ant.BuildEvent;

public class AntErrorException extends Exception {

    private static final long serialVersionUID = 1L;
    private BuildEvent buildEvent;
    private String err;
    private String out;

    public AntErrorException() {
        super();
    }

    public AntErrorException(Throwable cause) {
        super(cause);
    }

    public String getErr() {
        return this.err;
    }

    public BuildEvent getEvent() {
        return this.buildEvent;
    }

    @Override
    public String getMessage() {

        final String mes = super.getMessage();
        if ((mes.length() > 0) || (this.buildEvent == null)) {
            return mes;
        }
        return this.buildEvent.getMessage();
    }

    public String getOut() {
        return this.out;
    }

    @Override
    public StackTraceElement[] getStackTrace() {

        if (this.getCause() != null) {
            return this.getCause().getStackTrace();
        }
        return super.getStackTrace();
    }

    public void setErr(String err) {
        this.err = err;
    }

    public void setEvent(BuildEvent buildEvent) {
        this.buildEvent = buildEvent;
    }

    public void setOut(String out) {
        this.out = out;
    }

}
