/*
* Copyright (c) 2011, diablitozzz.org All rights reserved. Redistribution
* and use in source and binary forms, with or without modification, are
* permitted provided that the following conditions are met: * Redistributions
* of source code must retain the above copyright notice, this list of
* conditions and the following disclaimer. * Redistributions in binary form
* must reproduce the above copyright notice, this list of conditions and the
* following disclaimer in the documentation and/or other materials provided
* with the distribution. * Neither the name of diablitozzz.org nor the names of
* its contributors may be used to endorse or promote products derived from this
* software without specific prior written permission. THIS SOFTWARE IS PROVIDED
* BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
* EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS;
* OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package org.diablitozzz.jera.jetty.compile;

public class ScannerService {

    private final String scanDir;
    private final Scanner scanner;

    public ScannerService(String scanDir) {
        this.scanDir = scanDir;
        this.scanner = new Scanner();
        this.scanner.setRoot(this.scanDir);
        this.reScan();
    }

    public String getScanDir() {
        return this.scanDir;
    }

    public boolean isChange() {
        if (this.isEmpty()) {
            return false;
        }
        final Scanner current = new Scanner();
        current.setRoot(this.scanDir);
        current.scan();
        if (current.equals(this.scanner)) {
            return false;
        }
        this.reScan();
        return true;
    }

    public boolean isEmpty() {
        if (this.scanDir == null) {
            return true;
        }
        if (this.scanDir.isEmpty()) {
            return true;
        }
        return false;
    }

    public void reScan() {
        if (this.scanner != null) {
            this.scanner.scan();
        }
    }

}
