/*
 * Copyright (c) 2011, diablitozzz.org All import org.apache.commons.digester.annotations.rules.ObjectCreate;
 * import org.apache.commons.digester.annotations.rules.SetProperty;
 * following conditions are met: * Redistributions
 * of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer. * Redistributions in binary form
 * must reproduce the above copyright notice, this list of conditions and the
 * following disclaimer in the documentation and/or other materials provided
 * with the distribution. * Neither the name of diablitozzz.org nor the names of
 * its contributors may be used to endorse or promote products derived from this
 * software without specific prior written permission. THIS SOFTWARE IS PROVIDED
 * BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.diablitozzz.jera.jetty.config;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPathExpressionException;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

public class ConfigService {

    private File getFile(String path) throws FileNotFoundException, MalformedURLException, URISyntaxException
    {
        // file
        File file = new File(path);
        if (file.exists()) {
            return file;
        }
        // classloader
        ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
        URL url = classLoader.getResource(path);

        if (url == null) {
            throw new FileNotFoundException("Config not found " + path);
        }
        file = new File(url.toURI());
        return file;

    }

    public ConfigServer loadConfig(String path) throws URISyntaxException, ParserConfigurationException, SAXException, IOException, XPathExpressionException
    {
        // make utils
        ConfigUtils utils = new ConfigUtils();

        File configFile = this.getFile(path);
        Document document = utils.loadFile(configFile);

        // make current
        utils.getEnv().put("dir.current", configFile.getParent());

        // make server
        ConfigServer configServer = new ConfigServer();
        configServer.load(document, utils);

        return configServer;
    }
}
